/**
 * Hits2.java
 * tag weight
 * jama:http://math.nist.gov/javanumerics/jama/
 **/

import java.io.*;
import java.util.*;

public class Hits2{
    public static void main(String[] args) throws Exception{
	int d = 50; // Py[W̋tNĂy[Wmax

	try{
	    Maps MAP = new Maps();
	    if(args.length!=0){
		MAP.query = Tools.Input(args[0]);
	    }else{
		System.out.print("query:");
		MAP.query = Tools.Input();
	    }

	    //@RootSet̎擾
	    System.out.println("\n*Make RootSet2*");
	    MAP.BaseSet = Googly.todo(MAP.query);
	    MAP.RootSetSize = MAP.BaseSet.size();

	    // BaseSet̎擾 && RootSetTopicTagsT
	    System.out.print("\n*Make BaseSet2*");
	    MAP = GetURLs2.todo(MAP);

	    /* // _2BaseSet_first.txt
	    PrintWriter P_MAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("_2BaseSet_first.txt")));
	    P_MAP = Tools.Output(P_MAP,MAP,MAP.LHMap);
	    P_MAP.close();
	    */
	    MAP.BaseSetSize0 = MAP.BaseSet.size();
	    System.out.print("\nBaseSetSize2_0:"+MAP.BaseSetSize0);


	    // RootSetփNĂy[W̎擾
	    System.out.println("\n*Make BaseSet2(link:RootSet2)*");
	    MAP = Googly.todo2(MAP,d);
	    System.out.println("\nBaseSetSize2_1:"+MAP.BaseSet.size());

	    /* // _2DiffOya_linkBS.txt , _2BaseSet.txt
	    PrintWriter P_DiffOya =
		new PrintWriter(new BufferedWriter(new FileWriter("_2DiffOya_linkBS.txt")));
	    PrintWriter P_BaseSet =
	        new PrintWriter(new BufferedWriter(new FileWriter("_2BaseSet.txt")));
	    P_DiffOya = Tools.Output_DO(P_DiffOya,MAP.DiffOya);
	    P_BaseSet = Tools.Output(P_BaseSet,MAP.BaseSet);
	    P_DiffOya.close();
	    P_BaseSet.close();
	    */

	    // SearchTopicTags
	    MAP = GetURLs2.SearchTopicTags2(MAP);
	    PrintWriter P_TopicTags = 
		new PrintWriter(new BufferedWriter(new FileWriter("_2TopicTags.txt")));

	    P_TopicTags = Tools.Output(P_TopicTags,MAP.TopicTags);
	    P_TopicTags.close();


	    //TopicTagšvZ
	    ArrayList TopicTagsValue = new ArrayList();
	    TopicTagsValue = TopicTagValue2.todo(MAP);
	    /* // _2TTV.txt
	    PrintWriter P_TTV =
	        new PrintWriter(new BufferedWriter(new FileWriter("_2TTV.txt")));
	    //Tools.Output(TopicTagsValue);
	    P_TTV = Tools.Output(P_TTV,TopicTagsValue);
	    P_TTV.close();
	    */
	    MAP.TopicTags = new ArrayList(); //@


	    // 񎟌z̍쐬
	    int size = MAP.BaseSet.size();
	    double[][] Link = new double[size][size];
	    Link = MakeArray2.todo(TopicTagsValue,MAP,size);

	    // authority̌vZ
	    double[] Authority = new double[size];
	    Authority = CalculateAuthority_Hub.todo(Link,size);

	    // hub̌vZ
	    double[] Hub = new double[size];
	    Hub = CalculateAuthority_Hub.todo2(Link,size,Authority);

	    // sort
	    SortMaps AuthMAP = new SortMaps();
	    SortMaps HubMAP = new SortMaps();
	    AuthMAP = Sort.todo(MAP,Authority,size);
	    HubMAP = Sort.todo(MAP,Hub,size);
	    System.out.print("7");

	    //output
           PrintWriter P_AuthMAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("_2AuthorityWeight.txt")));
	    PrintWriter P_HubMAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("_2HubWeight.txt")));

	    P_AuthMAP = Tools.Output(P_AuthMAP,AuthMAP,size);
	    P_HubMAP = Tools.Output(P_HubMAP,HubMAP,size);
	    P_AuthMAP.close();
	    P_HubMAP.close();

	    System.out.print("\n2BaseSetSize0:"+MAP.BaseSetSize0);
	    System.out.println("\n2BaseSetSize:"+MAP.BaseSet.size());
	    System.out.println("<<<END<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");

	}catch(Exception e){
	    System.out.println("Hits2 error:"+e);
	}
    }

}



